import * as cxml from 'cxml';
import { Context } from './Context';
import { Type } from './Type';
import { Member } from './Member';
export declare enum TypeState {
    anonymous = 0,
    exported = 1,
}
export interface ImportContent {
    typeTbl: {
        [key: string]: Type;
    };
    memberTbl: {
        [key: string]: Member;
    };
}
export declare class Namespace extends cxml.NamespaceBase<Context, Namespace> {
    addRef(shortName: string, namespace: Namespace): void;
    getShortRef(id: number): string;
    getUsedImportTbl(): {
        [short: string]: Namespace;
    };
    getUsedImportList(): Namespace[];
    addType(type: Type): void;
    addMember(member: Member): void;
    exportType(type: Type): void;
    cachePath: string;
    /** Invisible document element defining the types of XML file root elements. */
    doc: Type;
    /** All types used in the document. */
    typeList: Type[];
    memberList: Member[];
    typeStateList: TypeState[];
    /** List of URL addresses of files with definitions for this namespace. */
    sourceList: string[];
    exported: boolean;
    private refList;
    private refTbl;
    private cacheDir;
    /** Short names used to reference other namespaces in schemas defining this namespace. */
    shortNameTbl: {
        [namespaceId: string]: string[];
    };
    /** Table of namespaces actually imported, by short name. */
    private importTbl;
    /** List of referenced type names from each imported namespace. */
    importContentTbl: {
        [namespaceId: string]: ImportContent;
    };
    /** True only for the special namespace containing primitives. */
    isPrimitiveSpace: boolean;
}
