// This file is part of cxsd, copyright (c) 2016 BusFaster Ltd.
// Released under the MIT license, see LICENSE.
"use strict";
var Type = (function () {
    function Type(name) {
        this.attributeTbl = {};
        this.childTbl = {};
        this.surrogateKey = Type.nextKey++;
        this.name = name;
    }
    // TODO: handle naming collisions between attributes and children,
    // and between namespaces.
    Type.prototype.buildMemberTbl = function () {
        var ref;
        for (var _i = 0, _a = this.attributeList || []; _i < _a.length; _i++) {
            ref = _a[_i];
            this.attributeTbl[ref.member.name] = ref;
        }
        for (var _b = 0, _c = this.childList || []; _b < _c.length; _b++) {
            ref = _c[_b];
            this.childTbl[ref.member.name] = ref;
        }
    };
    Type.nextKey = 0;
    Type.primitiveFlag = 1;
    Type.plainPrimitiveFlag = 2;
    Type.listFlag = 4;
    return Type;
}());
exports.Type = Type;
